/*!
 * TwistPHP - An open source PHP MVC framework built from the ground up.
 * Shadow Technologies Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Shadow Technologies Ltd. <contact@shadow-technologies.co.uk>
 * @license    https://www.gnu.org/licenses/gpl.html GPL License
 * @link       https://twistphp.com
 */

import {CustomSelect} from './CustomSelect';
import {CustomCheckbox} from './CustomCheckbox';
import {AjaxRequest} from './AjaxRequest';

$( () => {

	if (!window.TwistManagerAjaxURL){
		window.TwistManagerAjaxURL = '/manager/ajax';
	}

	let AJAX = new AjaxRequest(window.TwistManagerAjaxURL);


	//Customised the select boxes
	new CustomSelect();

	//Customised the checkboxes boxes
	new CustomCheckbox();

	/**
	 * Button confirmation classes
	 */
	$(document).on('click','.delete',function(e){
		var item = 'item';
		if($(this).attr('rel')){
			item = $(this).attr('rel');
		}
		//return confirm('Are you sure you want to delete this '+item+'?');
	});

	$(document).on('click','.cancel:not(.modalLink)',function(e){
		var item = 'item';
		if($(this).attr('rel')){
			item = $(this).attr('rel');
		}
		//return confirm('Are you sure you want to cancel '+item+'?');
	});

	$(document).on('click','.confirm:not(.modalLink)',function(e){
		var item = 'do this';
		if($(this).attr('rel')){
			item = $(this).attr('rel');
		}
		//return confirm('Are you sure you want to '+item+'?');
	});

	$(document).on('click','.logout',function(e){
		//return confirm('Are you sure you want to log out of the Web Portal?');
	});

	$(document).on('click','.modalLink',function(e){
		e.preventDefault();

		var item = 'item';
		if($(this).attr('data-title')){
			item = $(this).attr('data-title');
		}

		//if(!$(this).hasClass('cancel') || confirm('Are you sure you want to cancel '+item+'?')){
			AJAX.openModal($(this).attr('href'),{id: $(this).attr('rel')},$(this),1200);
		//}
	});

	$(document).on('submit','.ajaxFrom',function(e){
		e.preventDefault();
		AJAX.openModalForm($(this).attr('action'),'#'+$(this).attr('id'),$(this),1200);
	});

	/**
	 * Tab System JS
	 */
	$('.tabContainer .tabButtons li').removeClass('current').first().addClass('current');
	$('.tabContainer .tab').removeClass('current').first().addClass('current');

	$('.tabButtons li').on('click',function(){
		var clickedIndex = $(this).index();
		$(this).parent().find('li').removeClass('current').eq(clickedIndex).addClass('current');
		$(this).parents('.tabContainer').find('.tab').removeClass('current').eq(clickedIndex).addClass('current');
	});
});